#!/usr/local/bin/python
'''Make Amazon affiliate links.
'''
#
# Copyright (c) 2006 Satoshi Fukutomi <info@fuktommy.com>.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#

import cgitb; cgitb.enable()

import cgi
import sys
import md5
import urllib

datafile = '../xml/amazon.txt'
jsfile = '../xml/amazon.js'

def print_html():
    print 'Content-Type: text/html; charset=UTF-8'
    print
    data = file(datafile).read()
    sid = md5.new(data).hexdigest()
    sys.stdout.write('''<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8" />
  <title>Amazon</title>
  <link rev="made" href="mailto:webmaster@fuktommy.com" />
  <link rel="contents" href="/" title="Top" />
</head>
<body>
<h1><a href="">Amazon</a></h1>
<ul>
  <li><a href="https://affiliate.amazon.co.jp/gp/associates/network/reports/main.html">Amazon Home</a></li>
  <li><a href="/xml/amazon.js">Check Script</a></li>
</ul>
<form method="post" action="mkamazon.cgi"><p>
  <input type="submit" value="SAVE" /><br />
  <input type="hidden" name="sid" value="%s" />
  <textarea cols="50" rows="40" name="data">%s</textarea>
</p></form>
</body></html>
''' % (sid, cgi.escape(data)))


def check_sid(sid):
    data = file(datafile).read()
    hash = md5.new(data).hexdigest()
    return sid == hash

def update_jsfile(data):
    f = file(jsfile, 'w')
    f.write('''(function() {
    var words = [
''')

    lines = data.split('\n')
    for i in range(len(lines)):
        query = urllib.quote(lines[i].strip())
        if i < len(lines) - 1:
            f.write("'%s',\n" % query)
        else:
            f.write("'%s'\n" % query)

    f.write('''];
    var frameWidth = 468;
    var frameHeight = 60;
    switch (amazon_live_type) {
        case 9:
            frameWidth = 180;
            frameHeight = 150;
            break;
        case 13:
            frameWidth = 468;
            frameHeight = 60;
            break;
    }
    var link = words[Math.floor(Math.random()*words.length)];
    link = 'http://rcm-jp.amazon.co.jp/e/cm?t=fuktommysstor-22&o=9' +
           '&p=' + amazon_live_type + '&l=st1&mode=books-jp' +
           '&search=' + link + '&' +
           '=1&fc1=&lt1=&lc1=&bg1=&lc1=0000FF&bg1=EFEFEF&f=ifr';
    link = link.replace('&', '&amp;');
    document.write(
        '<iframe src="' + link +'" marginwidth="0" marginheight="0"' +
        ' width="' + frameWidth +'"' +
        ' height="' + frameHeight + '" border="0" frameborder="0"' +
        ' style="border:none;" scrolling="no"></iframe>');
})();
''')

def main():
    form = cgi.FieldStorage()
    cmd = form.getfirst('cmd', '')
    reader = None
    sid = form.getfirst('sid', '')
    data = form.getfirst('data', '').strip()
    if data and sid and check_sid(sid):
        file(datafile, 'w').write(data+'\n')
        update_jsfile(data)
    print_html()

if __name__ == '__main__':
    main()
