// RSS Readers
//
// Copyright (c) 2005,2006 Satoshi Fukutomi <info@fuktommy.com>.
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.
//

//
// Ajax RSS Read
//
var RSSread = Class.create();
RSSread.prototype = {
    initialize: function() {
    },

    read: function (uri) {
        new Ajax.Request(
                uri,
                {method: "get",
                 onComplete: this.callParser.bind(this)});
    },

    callParser: function (request) {
        this.parseXML(request.responseXML);
    }
};
// End of RSSread

//
// Recent RSS
//
var RecentRSS = Class.create();
RecentRSS.prototype = Object.extend((new RSSread), {
    initialize: function (topPageMode) {
        this.topPageMode = topPageMode;
    },

    parseXML: function (xml) {
        var recentList = new RecentList(xml);
        if (this.topPageMode) {
            var recentEntry = new EntryList(xml, recentSize);
        }
    }
});
// End of RecentRSS


//
// Archives RSS
//
var ArchivesRSS = Class.create();
ArchivesRSS.prototype = Object.extend((new RSSread), {
    parseXML: function (xml) {
        var archiveList = new ArchivesList(xml);
    }
});
// End of ArchivesRSS


//
// Monthly RSS
//
var MonthlyRSS = Class.create();
MonthlyRSS.prototype = Object.extend((new RSSread), {
    parseXML: function (xml) {
        new EntryList(xml);
    }
});
// End of MothlyRSS


//
// Entry RSS
//
var EntryRSS = Class.create();
EntryRSS.prototype = Object.extend((new RSSread), {
    parseXML: function (xml) {
        var entry = new Entry(xml.getElementsByTagName("item")[0]);
        entryCache.append(entry);
        var entryView = new EntryView(entry);
    }
});
// End of EntryRSS


//
// Entry RSS for view Content
//
var ContentRSS = Class.create();
ContentRSS.prototype = Object.extend((new RSSread), {
    initialize: function (panel) {
        this.panel = panel;
    },

    parseXML: function (xml) {
        var entry = new Entry(xml.getElementsByTagName("item")[0]);
        entryCache.append(entry);
        this.panel.setContent(entry.content);
    }
});
// End of ContentRSS
