#!/usr/local/bin/python
'''Simple Uploader.
'''
#
# Copyright (c) 2006 Satoshi Fukutomi <info@fuktommy.com>.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#

import cgitb; cgitb.enable()

import re
import cgi
import os.path
from time import time

updir = '../img'

def print_html():
    print 'Content-Type: text/html; charset=UTF-8'
    print
    print '''<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8" />
  <title>Uploader</title>
  <link rev="made" href="mailto:webmaster@fuktommy.com" />
  <link rel="contents" href="/" title="Top" />
</head>
<body>
<h1>Uploader</h1>
<ul>
  <li><a href="/img/">Check Files</a></li>
</ul>
<form method="post" action="upload.cgi" enctype="multipart/form-data"><p>
  <input type="file" name="file" size="19" value="" />
  <input type="submit" value="UPLOAD" />
</p></form>
</body></html>
'''

def save_file(filename, filedata):
    suffix = 'txt'
    found = re.search(r'\.([^.]+)$', filename)
    if found:
        suffix = found.group(1).lower()
    newfilename = '%d.%s' % (time(), suffix)
    filepath = os.path.join(updir, newfilename)
    file(filepath, 'wb').write(filedata)

def main():
    form = cgi.FieldStorage()
    if 'file' in form:
        filedata = form['file']
        if filedata.filename and filedata.value:
            save_file(filedata.filename, filedata.value)
    print_html()

if __name__ == '__main__':
    main()
